
/////////////////////////////////////////////////////////////////////
// Mapper 44

class NES_mapper44 : public NES_mapper
{
  friend void adopt_MPRD(SnssMapperBlock* block, NES* nes);
  friend int extract_MPRD(SnssMapperBlock* block, NES* nes);

public:
  NES_mapper44(NES* parent) : NES_mapper(parent) {}
  ~NES_mapper44() {}

  void  Reset();
  void  MemoryWrite(uint32 addr, uint8 data);
  void  HSync(uint32 scanline);

protected:
  uint8  regs[8];

  uint32 rom_bank;
  uint32 prg0,prg1;
  uint32 chr01,chr23,chr4,chr5,chr6,chr7;

  uint32 chr_swap() { return regs[0] & 0x80; }
  uint32 prg_swap() { return regs[0] & 0x40; }

  uint8 irq_enabled; // IRQs enabled
  uint8 irq_counter; // IRQ scanline counter, decreasing
  uint8 irq_latch;   // IRQ scanline counter latch

  void MMC3_set_CPU_banks()
  {
    if(prg_swap())
    {
      set_CPU_bank4(16*rom_bank+14);
      set_CPU_bank5(16*rom_bank+prg1);
      set_CPU_bank6(16*rom_bank+prg0);
      set_CPU_bank7(16*rom_bank+15);
    }
    else
    {
      set_CPU_bank4(16*rom_bank+prg0);
      set_CPU_bank5(16*rom_bank+prg1);
      set_CPU_bank6(16*rom_bank+14);
      set_CPU_bank7(16*rom_bank+15);
    }
  }

  void MMC3_set_PPU_banks()
  {
    if(num_1k_VROM_banks)
    {
      if(chr_swap())
      {
        set_PPU_bank0(128*rom_bank+chr4);
        set_PPU_bank1(128*rom_bank+chr5);
        set_PPU_bank2(128*rom_bank+chr6);
        set_PPU_bank3(128*rom_bank+chr7);
        set_PPU_bank4(128*rom_bank+chr01);
        set_PPU_bank5(128*rom_bank+chr01+1);
        set_PPU_bank6(128*rom_bank+chr23);
        set_PPU_bank7(128*rom_bank+chr23+1);
      }
      else
      {
        set_PPU_bank0(128*rom_bank+chr01);
        set_PPU_bank1(128*rom_bank+chr01+1);
        set_PPU_bank2(128*rom_bank+chr23);
        set_PPU_bank3(128*rom_bank+chr23+1);
        set_PPU_bank4(128*rom_bank+chr4);
        set_PPU_bank5(128*rom_bank+chr5);
        set_PPU_bank6(128*rom_bank+chr6);
        set_PPU_bank7(128*rom_bank+chr7);
      }
    }
  }

private:
};
/////////////////////////////////////////////////////////////////////

